
;CodeVisionAVR C Compiler V1.25.8 Professional
;(C) Copyright 1998-2007 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATmega48
;Clock frequency        : 16,000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External SRAM size     : 0
;Data Stack size        : 340 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;8 bit enums            : Yes
;Word align FLASH struct: No
;Enhanced core instructions    : On
;Smart register allocation : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega48
	#pragma AVRPART MEMORY PROG_FLASH 4096
	#pragma AVRPART MEMORY EEPROM 256
	#pragma AVRPART MEMORY INT_SRAM SIZE 512
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x100

	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU EECR=0x1F
	.EQU EEDR=0x20
	.EQU EEARL=0x21
	.EQU EEARH=0x22
	.EQU SPSR=0x2D
	.EQU SPDR=0x2E
	.EQU SMCR=0x33
	.EQU MCUSR=0x34
	.EQU MCUCR=0x35
	.EQU WDTCSR=0x60
	.EQU UCSR0A=0xC0
	.EQU UDR0=0xC6
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F
	.EQU GPIOR0=0x1E

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	LDI  R23,BYTE4(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+@1,R0
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "laser.vec"
	.INCLUDE "laser.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	WDR
	IN   R26,MCUSR
	CBR  R26,8
	OUT  MCUSR,R26
	STS  WDTCSR,R31
	STS  WDTCSR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x200)
	LDI  R25,HIGH(0x200)
	LDI  R26,LOW(0x100)
	LDI  R27,HIGH(0x100)
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;GPIOR0 INITIALIZATION
	LDI  R30,__GPIOR0_INIT
	OUT  GPIOR0,R30

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x2FF)
	OUT  SPL,R30
	LDI  R30,HIGH(0x2FF)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x254)
	LDI  R29,HIGH(0x254)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x254
;       1 /*****************************************************
;       2 CodeWizardAVR V1.25.8 Professional
;       3 
;       4 Project : Laser Controller
;       5 Version : 1
;       6 Date    : 22.05.2008
;       7 Author  : Serega
;       8 Company : Serega Digital
;       9 Comments:
;      10 
;      11 Chip type           : ATmega48
;      12 Clock frequency     : 16,000000 MHz
;      13 Memory model        : Small
;      14 External SRAM size  : 0
;      15 Data Stack size     : 128
;      16 *****************************************************/
;      17 
;      18 #include <mega48.h>
;      19 	#ifndef __SLEEP_DEFINED__
	#ifndef __SLEEP_DEFINED__
;      20 	#define __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
;      21 	.EQU __se_bit=0x01
	.EQU __se_bit=0x01
;      22 	.EQU __sm_mask=0x0E
	.EQU __sm_mask=0x0E
;      23 	.EQU __sm_adc_noise_red=0x02
	.EQU __sm_adc_noise_red=0x02
;      24 	.EQU __sm_powerdown=0x04
	.EQU __sm_powerdown=0x04
;      25 	.EQU __sm_powersave=0x06
	.EQU __sm_powersave=0x06
;      26 	.EQU __sm_standby=0x0C
	.EQU __sm_standby=0x0C
;      27 	.SET power_ctrl_reg=smcr
	.SET power_ctrl_reg=smcr
;      28 	#endif
	#endif
;      29 #include <delay.h>
;      30 #include <math.h>
;      31 
;      32 #define TWINT 128
;      33 #define TWSTA 32
;      34 #define TWSTO 16
;      35 #define TWEN  4
;      36 #define TWEA  64
;      37 #define EEPROM_BUS_ADDRESS 0xa0
;      38 
;      39 //Fuctions' prototypes
;      40 char ee_read(unsigned int);
;      41 char twi_read(char);
;      42 void twi_write(char);
;      43 void twi_start(void);
;      44 void twi_stop(void);
;      45 void out(char,char,char);
;      46 void circle(float,char);
;      47 void effect1(char);
;      48 void effect2(char);
;      49 void effect3(void);
;      50 void effect4(void);
;      51 void effect5(void);
;      52 //
;      53 
;      54 //Global variables declaration
;      55 char next=0;
;      56 char loop=0;
;      57 char increment=1;
;      58 char repeat;
;      59 //
;      60 char twi_read(char ACK)
;      61 {

	.CSEG
_twi_read:
;      62         if(ACK) TWCR=TWINT|TWEA|TWEN;
;	ACK -> Y+0
	LD   R30,Y
	CPI  R30,0
	BREQ _0x4
	LDI  R30,LOW(196)
	RJMP _0xDD
;      63         else TWCR=TWINT|TWEN;
_0x4:
	LDI  R30,LOW(132)
_0xDD:
	STS  188,R30
;      64         while(!(TWCR&(TWINT)));
_0x6:
	RCALL SUBOPT_0x0
	BREQ _0x6
;      65         return TWDR;
	LDS  R30,187
	RJMP _0xDC
;      66 }
;      67 void twi_write(char data)
;      68 {
_twi_write:
;      69         TWDR=data;
;	data -> Y+0
	LD   R30,Y
	STS  187,R30
;      70         TWCR=TWINT|TWEN;
	LDI  R30,LOW(132)
	RCALL SUBOPT_0x1
;      71         while(!(TWCR&(TWINT)));
_0x9:
	RCALL SUBOPT_0x0
	BREQ _0x9
;      72 }
_0xDC:
	ADIW R28,1
	RET
;      73 void twi_start(void)
;      74 {
_twi_start:
;      75         TWCR=TWINT|TWSTA|TWEN;
	LDI  R30,LOW(164)
	RCALL SUBOPT_0x1
;      76         while(!(TWCR&(TWINT)));
_0xC:
	RCALL SUBOPT_0x0
	BREQ _0xC
;      77 }
	RET
;      78 void twi_stop(void)
;      79 {
_twi_stop:
;      80         TWCR=TWINT|TWEN|TWSTO;
	LDI  R30,LOW(148)
	RCALL SUBOPT_0x1
;      81 }
	RET
;      82 char ee_read(unsigned int adress)
;      83 {
_ee_read:
;      84         char data;
;      85         twi_start();
	ST   -Y,R17
;	adress -> Y+1
;	data -> R17
	RCALL SUBOPT_0x2
;      86         twi_write(EEPROM_BUS_ADDRESS);
;      87         twi_write((unsigned char)(adress>>8));
	LDD  R30,Y+2
	ANDI R31,HIGH(0x0)
	RCALL SUBOPT_0x3
;      88         twi_write((unsigned char)(adress&255));
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	ANDI R31,HIGH(0xFF)
	RCALL SUBOPT_0x3
;      89         twi_start();
	RCALL _twi_start
;      90         twi_write(EEPROM_BUS_ADDRESS|1);
	LDI  R30,LOW(161)
	RCALL SUBOPT_0x3
;      91         data=twi_read(0);
	RCALL SUBOPT_0x4
	RCALL _twi_read
	MOV  R17,R30
;      92         twi_stop();
	RCALL _twi_stop
;      93         return data;
	MOV  R30,R17
	LDD  R17,Y+0
	ADIW R28,3
	RET
;      94 }
;      95 
;      96 
;      97 void read_picture(void)
;      98 {
_read_picture:
;      99         char x,y,z;
;     100         unsigned int i;
;     101         unsigned int counter,offset;
;     102         unsigned int points_number;
;     103         char frames_number,f;//,r;
;     104         char frame_repeats;
;     105 
;     106         frames_number=ee_read(0);
	SBIW R28,8
	RCALL __SAVELOCR6
;	x -> R17
;	y -> R16
;	z -> R19
;	i -> R20,R21
;	counter -> Y+12
;	offset -> Y+10
;	points_number -> Y+8
;	frames_number -> R18
;	f -> Y+7
;	frame_repeats -> Y+6
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	RCALL SUBOPT_0x5
	MOV  R18,R30
;     107         frame_repeats=ee_read(1);
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RCALL SUBOPT_0x5
	STD  Y+6,R30
;     108 
;     109         while(1)
_0xF:
;     110         {
;     111         counter=1;
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RCALL SUBOPT_0x6
;     112         for(f=1;f<=frames_number;f++)
	LDI  R30,LOW(1)
	STD  Y+7,R30
_0x13:
	LDD  R26,Y+7
	CP   R18,R26
	BRSH PC+2
	RJMP _0x14
;     113         {
;     114                 points_number=ee_read(++counter);
	RCALL SUBOPT_0x7
	LDI  R31,0
	STD  Y+8,R30
	STD  Y+8+1,R31
;     115                 points_number=points_number<<8;
	LDD  R31,Y+8
	LDI  R30,LOW(0)
	STD  Y+8,R30
	STD  Y+8+1,R31
;     116                 points_number|=ee_read(++counter);
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x8
	LDI  R31,0
	OR   R30,R26
	OR   R31,R27
	STD  Y+8,R30
	STD  Y+8+1,R31
;     117                 ++counter;
	LDD  R30,Y+12
	LDD  R31,Y+12+1
	ADIW R30,1
	RCALL SUBOPT_0x6
;     118                 for(repeat=0;repeat<frame_repeats;repeat+=increment)
	CLR  R5
_0x16:
	LDD  R30,Y+6
	CP   R5,R30
	BRLO PC+2
	RJMP _0x17
;     119                 {
;     120                         #asm("wdr");
	wdr
;     121                         offset=counter;
	LDD  R30,Y+12
	LDD  R31,Y+12+1
	STD  Y+10,R30
	STD  Y+10+1,R31
;     122                         /////////////////////////////
;     123                         twi_start();
	RCALL SUBOPT_0x2
;     124                         twi_write(EEPROM_BUS_ADDRESS);
;     125                         twi_write((unsigned char)(counter>>8));
	LDD  R30,Y+13
	ANDI R31,HIGH(0x0)
	RCALL SUBOPT_0x3
;     126                         twi_write((unsigned char)(counter));//&255
	LDD  R30,Y+12
	RCALL SUBOPT_0x3
;     127                         twi_start();
	RCALL _twi_start
;     128                         twi_write(EEPROM_BUS_ADDRESS|1);
	LDI  R30,LOW(161)
	RCALL SUBOPT_0x3
;     129                         ////////////////////////////
;     130                         for(i=1;i<=points_number;i++)
	__GETWRN 20,21,1
_0x19:
	RCALL SUBOPT_0x9
	BRLO _0x1A
;     131                         {
;     132                                 x=twi_read(1);
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _twi_read
	MOV  R17,R30
;     133                                 y=twi_read(1);
	RCALL SUBOPT_0xA
	RCALL _twi_read
	MOV  R16,R30
;     134                                 if(i!=points_number) z=twi_read(1);
	RCALL SUBOPT_0x9
	BREQ _0x1B
	LDI  R30,LOW(1)
	RJMP _0xDE
;     135                                 else z=twi_read(0);
_0x1B:
	LDI  R30,LOW(0)
_0xDE:
	ST   -Y,R30
	RCALL _twi_read
	MOV  R19,R30
;     136                                 out(x,y,z);
	ST   -Y,R17
	ST   -Y,R16
	ST   -Y,R19
	RCALL _out
;     137                                 if(points_number<50) delay_us(200);
	RCALL SUBOPT_0x8
	SBIW R26,50
	BRSH _0x1D
	__DELAY_USW 800
;     138                                 else if(points_number<150) delay_us(100);
	RJMP _0x1E
_0x1D:
	RCALL SUBOPT_0x8
	CPI  R26,LOW(0x96)
	LDI  R30,HIGH(0x96)
	CPC  R27,R30
	BRSH _0x1F
	RCALL SUBOPT_0xB
;     139                                 else if(points_number<200)delay_us(50);
	RJMP _0x20
_0x1F:
	RCALL SUBOPT_0x8
	CPI  R26,LOW(0xC8)
	LDI  R30,HIGH(0xC8)
	CPC  R27,R30
	BRSH _0x21
	__DELAY_USW 200
;     140                                 offset+=3;
_0x21:
_0x20:
_0x1E:
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	ADIW R30,3
	STD  Y+10,R30
	STD  Y+10+1,R31
;     141                         }
	__ADDWRN 20,21,1
	RJMP _0x19
_0x1A:
;     142                         twi_stop();
	RCALL _twi_stop
;     143                 }
	ADD  R5,R6
	RJMP _0x16
_0x17:
;     144                 counter=offset;
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	RCALL SUBOPT_0x6
;     145                 --counter;
	LDD  R30,Y+12
	LDD  R31,Y+12+1
	SBIW R30,1
	RCALL SUBOPT_0x6
;     146         }
	LDD  R30,Y+7
	SUBI R30,-LOW(1)
	STD  Y+7,R30
	RJMP _0x13
_0x14:
;     147         }
	RJMP _0xF
;     148 }
;     149 
;     150 void select_effect(void)
;     151 {
_select_effect:
;     152 ef1:
_0x22:
;     153         effect1(0);
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0xC
;     154         if(loop&(!next)) goto ef1;
	BRNE _0x22
;     155 ef2:
_0x24:
;     156         effect2(0);
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0xD
;     157         //effect2(1);
;     158         if(loop&(!next)) goto ef2;
	BRNE _0x24
;     159 ef3:
_0x26:
;     160         effect1(1);
	RCALL SUBOPT_0xA
	RCALL SUBOPT_0xC
;     161         if(loop&(!next)) goto ef3;
	BRNE _0x26
;     162 ef4:
_0x28:
;     163         effect2(1);
	RCALL SUBOPT_0xA
	RCALL SUBOPT_0xD
;     164         if(loop&(!next)) goto ef4;
	BRNE _0x28
;     165 ef5:
_0x2A:
;     166         effect3();
	RCALL _effect3
;     167         if(loop&(!next)) goto ef5;
	RCALL SUBOPT_0xE
	BRNE _0x2A
;     168 
;     169 ef6:
_0x2C:
;     170         effect5();
	RCALL _effect5
;     171         if(loop&(!next)) goto ef6;
	RCALL SUBOPT_0xE
	BRNE _0x2C
;     172 ef7:
_0x2E:
;     173         //effect5();
;     174         effect4();
	RCALL _effect4
;     175         if(loop&(!next)) goto ef7;
	RCALL SUBOPT_0xE
	BRNE _0x2E
;     176 }
	RET
;     177 
;     178 void circle(float step,char delay)
;     179 {
_circle:
;     180         float angle;
;     181         unsigned char xcoord;
;     182         unsigned char ycoord;
;     183         for(angle=0;angle<=6.283185;angle+=step) //step=0.1
	SBIW R28,4
	RCALL __SAVELOCR2
;	step -> Y+7
;	delay -> Y+6
;	angle -> Y+2
;	xcoord -> R17
;	ycoord -> R16
	__CLRD1S 2
_0x31:
	RCALL SUBOPT_0xF
	__GETD1N 0x40C90FDA
	RCALL __CMPF12
	BREQ PC+3
	BRCS PC+2
	RJMP _0x32
;     184         {
;     185                 xcoord=(char)(cos(angle)*127);
	RCALL SUBOPT_0x10
	RCALL _cos
	RCALL SUBOPT_0x11
	MOV  R17,R30
;     186                 ycoord=(char)(sin(angle)*127);
	RCALL SUBOPT_0x10
	RCALL _sin
	RCALL SUBOPT_0x11
	MOV  R16,R30
;     187                 out(xcoord+127,ycoord+127,0);
	MOV  R30,R17
	SUBI R30,-LOW(127)
	ST   -Y,R30
	MOV  R30,R16
	SUBI R30,-LOW(127)
	ST   -Y,R30
	RCALL SUBOPT_0x4
	RCALL _out
;     188                 if(delay) delay_us(700);
	LDD  R30,Y+6
	CPI  R30,0
	BREQ _0x33
	RCALL SUBOPT_0x12
;     189                 PORTD.6=1;
_0x33:
	SBI  0xB,6
;     190                 if(delay) delay_ms(5);
	LDD  R30,Y+6
	CPI  R30,0
	BREQ _0x36
	RCALL SUBOPT_0x13
;     191 
;     192         };
_0x36:
	__GETD1S 7
	RCALL SUBOPT_0xF
	RCALL SUBOPT_0x14
	RJMP _0x31
_0x32:
;     193 }
	RCALL __LOADLOCR2
	ADIW R28,11
	RET
;     194 
;     195 void effect1(char plane)//poyavleniye luchey
;     196 {
_effect1:
;     197         char i;
;     198         char j;
;     199         char counter;
;     200         next=0;
	RCALL __SAVELOCR4
;	plane -> Y+4
;	i -> R17
;	j -> R16
;	counter -> R19
	CLR  R4
;     201                 for(i=0;i<=4;i++)
	LDI  R17,LOW(0)
_0x38:
	CPI  R17,5
	BRSH _0x39
;     202                 {
;     203                         for(j=0;j<=100;j++)
	LDI  R16,LOW(0)
_0x3B:
	CPI  R16,101
	BRSH _0x3C
;     204                         {
;     205                                 counter=0;
	RCALL SUBOPT_0x15
;     206                                 delay_ms(2);
;     207                                 while(counter<=i)
_0x3D:
	CP   R17,R19
	BRLO _0x3F
;     208                                 {
;     209                                         if(plane) out(counter*51,127,1);
	RCALL SUBOPT_0x16
	BREQ _0x40
	RCALL SUBOPT_0x17
	ST   -Y,R30
	LDI  R30,LOW(127)
	RJMP _0xDF
;     210                                         else      out(127,counter*51,1);
_0x40:
	LDI  R30,LOW(127)
	ST   -Y,R30
	RCALL SUBOPT_0x17
_0xDF:
	ST   -Y,R30
	RCALL SUBOPT_0xA
	RCALL _out
;     211                                         delay_ms(5);
	RCALL SUBOPT_0x13
;     212                                         ++counter;
	SUBI R19,-LOW(1)
;     213                                 };
	RJMP _0x3D
_0x3F:
;     214                                 if(plane) out(0,127,0);
	RCALL SUBOPT_0x16
	BREQ _0x42
	RCALL SUBOPT_0x4
	LDI  R30,LOW(127)
	RJMP _0xE0
;     215                                 else      out(127,0,0);
_0x42:
	LDI  R30,LOW(127)
	ST   -Y,R30
	LDI  R30,LOW(0)
_0xE0:
	ST   -Y,R30
	RCALL SUBOPT_0x4
	RCALL _out
;     216                         };
	SUBI R16,-1
	RJMP _0x3B
_0x3C:
;     217                         #asm("wdr");
	wdr
;     218                         if(next) return;
	TST  R4
	BRNE _0xDB
;     219                 };
	SUBI R17,-1
	RJMP _0x38
_0x39:
;     220 
;     221 }
_0xDB:
	RCALL __LOADLOCR4
	ADIW R28,5
	RET
;     222 
;     223 void effect2(char plane)//dvijeniye luchey
;     224 {
_effect2:
;     225         char i;
;     226         char j;
;     227         char counter;
;     228         next=0;
	RCALL __SAVELOCR4
;	plane -> Y+4
;	i -> R17
;	j -> R16
;	counter -> R19
	CLR  R4
;     229         for(j=0;j<=3;j++)
	LDI  R16,LOW(0)
_0x46:
	CPI  R16,4
	BRLO PC+2
	RJMP _0x47
;     230         {
;     231         for(i=127;i<=254;i+=2)
	LDI  R17,LOW(127)
_0x49:
	CPI  R17,255
	BRSH _0x4A
;     232         {
;     233                                 counter=0;
	RCALL SUBOPT_0x15
;     234                                 delay_ms(2);
;     235                                 while(counter<=4)
_0x4B:
	CPI  R19,5
	BRSH _0x4D
;     236                                 {
;     237                                         if(plane) out(counter*51,i,1);
	RCALL SUBOPT_0x16
	BREQ _0x4E
	RCALL SUBOPT_0x17
	RCALL SUBOPT_0x18
	RJMP _0xE1
;     238                                         else      out(i,counter*51,1);
_0x4E:
	ST   -Y,R17
	RCALL SUBOPT_0x17
	ST   -Y,R30
_0xE1:
	LDI  R30,LOW(1)
	RCALL SUBOPT_0x19
;     239                                         delay_ms(5);
	RCALL SUBOPT_0x13
;     240                                         ++counter;
	SUBI R19,-LOW(1)
;     241                                 };
	RJMP _0x4B
_0x4D:
;     242                                 if(plane) out(0,i,0);
	RCALL SUBOPT_0x16
	BREQ _0x50
	RCALL SUBOPT_0x4
	ST   -Y,R17
	RJMP _0xE2
;     243                                 else      out(i,0,0);
_0x50:
	RCALL SUBOPT_0x1A
_0xE2:
	LDI  R30,LOW(0)
	RCALL SUBOPT_0x19
;     244                         #asm("wdr");
	wdr
;     245                         if(next) return;
	TST  R4
	BREQ _0x52
	RCALL __LOADLOCR4
	ADIW R28,5
	RET
;     246         };
_0x52:
	SUBI R17,-LOW(2)
	RJMP _0x49
_0x4A:
;     247         for(i=254;i>=1;i-=2)
	LDI  R17,LOW(254)
_0x54:
	CPI  R17,1
	BRLO _0x55
;     248         {
;     249                                 counter=0;
	RCALL SUBOPT_0x15
;     250                                 delay_ms(2);
;     251                                 while(counter<=4)
_0x56:
	CPI  R19,5
	BRSH _0x58
;     252                                 {
;     253                                         if(plane) out(counter*51,i,1);
	RCALL SUBOPT_0x16
	BREQ _0x59
	RCALL SUBOPT_0x17
	RCALL SUBOPT_0x18
	RJMP _0xE3
;     254                                         else      out(i,counter*51,1);
_0x59:
	ST   -Y,R17
	RCALL SUBOPT_0x17
	ST   -Y,R30
_0xE3:
	LDI  R30,LOW(1)
	RCALL SUBOPT_0x19
;     255                                         delay_ms(5);
	RCALL SUBOPT_0x13
;     256                                         ++counter;
	SUBI R19,-LOW(1)
;     257                                 };
	RJMP _0x56
_0x58:
;     258                                 if(plane) out(0,i,0);
	RCALL SUBOPT_0x16
	BREQ _0x5B
	RCALL SUBOPT_0x4
	ST   -Y,R17
	RJMP _0xE4
;     259                                 else      out(i,0,0);
_0x5B:
	RCALL SUBOPT_0x1A
_0xE4:
	LDI  R30,LOW(0)
	RCALL SUBOPT_0x19
;     260                         #asm("wdr");
	wdr
;     261                         if(next) return;
	TST  R4
	BREQ _0x5D
	RCALL __LOADLOCR4
	ADIW R28,5
	RET
;     262         };
_0x5D:
	SUBI R17,LOW(2)
	RJMP _0x54
_0x55:
;     263         for(i=1;i<=127;i+=2)
	LDI  R17,LOW(1)
_0x5F:
	CPI  R17,128
	BRSH _0x60
;     264         {
;     265                                 counter=0;
	RCALL SUBOPT_0x15
;     266                                 delay_ms(2);
;     267                                 while(counter<=4)
_0x61:
	CPI  R19,5
	BRSH _0x63
;     268                                 {
;     269                                         if(plane) out(counter*51,i,1);
	RCALL SUBOPT_0x16
	BREQ _0x64
	RCALL SUBOPT_0x17
	RCALL SUBOPT_0x18
	RJMP _0xE5
;     270                                         else      out(i,counter*51,1);
_0x64:
	ST   -Y,R17
	RCALL SUBOPT_0x17
	ST   -Y,R30
_0xE5:
	LDI  R30,LOW(1)
	RCALL SUBOPT_0x19
;     271                                         delay_ms(5);
	RCALL SUBOPT_0x13
;     272                                         ++counter;
	SUBI R19,-LOW(1)
;     273                                 };
	RJMP _0x61
_0x63:
;     274                                 if(plane) out(0,i,0);
	RCALL SUBOPT_0x16
	BREQ _0x66
	RCALL SUBOPT_0x4
	ST   -Y,R17
	RJMP _0xE6
;     275                                 else      out(i,0,0);
_0x66:
	RCALL SUBOPT_0x1A
_0xE6:
	LDI  R30,LOW(0)
	RCALL SUBOPT_0x19
;     276                         #asm("wdr");
	wdr
;     277                         if(next) return;
	TST  R4
	BRNE _0xDA
;     278         };
	SUBI R17,-LOW(2)
	RJMP _0x5F
_0x60:
;     279         };
	SUBI R16,-1
	RJMP _0x46
_0x47:
;     280 
;     281 }
_0xDA:
	RCALL __LOADLOCR4
	ADIW R28,5
	RET
;     282 
;     283 void effect3(void)//vrashyayushiesya luchi
;     284 {
_effect3:
;     285         int i;
;     286         float step;
;     287         next=0;
	SBIW R28,4
	RCALL __SAVELOCR2
;	i -> R16,R17
;	step -> Y+2
	CLR  R4
;     288         step=1.1;
	__GETD1N 0x3F8CCCCD
	__PUTD1S 2
;     289         for(i=0;i<=1200;i++)
	__GETWRN 16,17,0
_0x6A:
	__CPWRN 16,17,1201
	BRGE _0x6B
;     290         {
;     291                 circle(step,1);
	RCALL SUBOPT_0x10
	RCALL SUBOPT_0xA
	RCALL _circle
;     292                 if(next) return;
	TST  R4
	BRNE _0xD9
;     293                 step+=0.0005;
	__GETD1S 2
	__GETD2N 0x3A03126F
	RCALL SUBOPT_0x14
;     294         };
	__ADDWRN 16,17,1
	RJMP _0x6A
_0x6B:
;     295 }
_0xD9:
	RCALL __LOADLOCR2
	ADIW R28,6
	RET
;     296 
;     297 void effect4(void)//tonnel'
;     298 {
_effect4:
;     299         int i;
;     300         for(i=0;i<=800;i++)
	RCALL __SAVELOCR2
;	i -> R16,R17
	__GETWRN 16,17,0
_0x6E:
	__CPWRN 16,17,801
	BRGE _0x6F
;     301         {
;     302                 circle(0.2,0);
	__GETD1N 0x3E4CCCCD
	RCALL __PUTPARD1
	RCALL SUBOPT_0x4
	RCALL _circle
;     303                 if(next) return;
	TST  R4
	BREQ _0x70
	RCALL __LOADLOCR2P
	RET
;     304                 #asm("wdr");
_0x70:
	wdr
;     305         };
	__ADDWRN 16,17,1
	RJMP _0x6E
_0x6F:
;     306 }
	RCALL __LOADLOCR2P
	RET
;     307 
;     308 void effect5(void)//ploskosti
;     309 {
_effect5:
	PUSH R15
;     310         char i;
;     311         char j;
;     312         char k;
;     313         char l;
;     314         bit plane;
;     315         next=0;
	RCALL __SAVELOCR4
;	i -> R17
;	j -> R16
;	k -> R19
;	l -> R18
;	plane -> R15.0
	CLR  R4
;     316         for(l=1;l<=4;l++)
	LDI  R18,LOW(1)
_0x72:
	CPI  R18,5
	BRLO PC+2
	RJMP _0x73
;     317         {
;     318         for(i=127;i<=254;i++)
;	plane -> R15.0
	LDI  R17,LOW(127)
_0x75:
	CPI  R17,255
	BRSH _0x76
;     319         {
;     320                 k=255-i;
;	plane -> R15.0
	RCALL SUBOPT_0x1B
;     321                 for(j=k;j<=i;j++)
_0x78:
	CP   R17,R16
	BRLO _0x79
;     322                 {
;     323                         if(plane)out(j,j,1);
;	plane -> R15.0
	SBRS R15,0
	RJMP _0x7A
	ST   -Y,R16
	RJMP _0xE7
;     324                         else out(255-j,j,1);
_0x7A:
	LDI  R30,LOW(255)
	SUB  R30,R16
	ST   -Y,R30
_0xE7:
	ST   -Y,R16
	RCALL SUBOPT_0xA
	RCALL _out
;     325                         if(j==k)
	CP   R19,R16
	BRNE _0x7C
;     326                         {
;     327                                 PORTD.6=0;
;	plane -> R15.0
	RCALL SUBOPT_0x1C
;     328                                 delay_ms(4);
;     329                                 PORTD.6=1;
;     330                         };
_0x7C:
;     331                         delay_us(80);
	RCALL SUBOPT_0x1D
;     332                 };
	SUBI R16,-1
	RJMP _0x78
_0x79:
;     333                 if(next) return;
	TST  R4
	BREQ _0x81
	RCALL __LOADLOCR4
	ADIW R28,4
	POP  R15
	RET
;     334         };
_0x81:
	SUBI R17,-1
	RJMP _0x75
_0x76:
;     335         #asm("wdr");
	wdr
;     336         for(i=254;i>=127;i--)
	LDI  R17,LOW(254)
_0x83:
	CPI  R17,127
	BRLO _0x84
;     337         {
;     338                 k=255-i;
;	plane -> R15.0
	RCALL SUBOPT_0x1B
;     339                 for(j=k;j<=i;j++)
_0x86:
	CP   R17,R16
	BRLO _0x87
;     340                 {
;     341                         if(plane)out(j,j,1);
;	plane -> R15.0
	SBRS R15,0
	RJMP _0x88
	ST   -Y,R16
	RJMP _0xE8
;     342                         else out(255-j,j,1);
_0x88:
	LDI  R30,LOW(255)
	SUB  R30,R16
	ST   -Y,R30
_0xE8:
	ST   -Y,R16
	RCALL SUBOPT_0xA
	RCALL _out
;     343                         if(j==k)
	CP   R19,R16
	BRNE _0x8A
;     344                         {
;     345                                 PORTD.6=0;
;	plane -> R15.0
	RCALL SUBOPT_0x1C
;     346                                 delay_ms(4);
;     347                                 PORTD.6=1;
;     348                         };
_0x8A:
;     349                         delay_us(80);
	RCALL SUBOPT_0x1D
;     350                 };
	SUBI R16,-1
	RJMP _0x86
_0x87:
;     351                 if(next) return;
	TST  R4
	BREQ _0x8F
	RCALL __LOADLOCR4
	ADIW R28,4
	POP  R15
	RET
;     352                 PORTD.6=0;
_0x8F:
	CBI  0xB,6
;     353                 delay_us(700);
	RCALL SUBOPT_0x12
;     354                 PORTD.6=1;
	SBI  0xB,6
;     355         };
	SUBI R17,1
	RJMP _0x83
_0x84:
;     356         #asm("wdr");
	wdr
;     357         plane=~plane;
	LDI  R30,LOW(1)
	EOR  R15,R30
;     358         };
	SUBI R18,-1
	RJMP _0x72
_0x73:
;     359 }
	RCALL __LOADLOCR4
	ADIW R28,4
	POP  R15
	RET
;     360 void out(char x, char y, char blanking)
;     361 {
_out:
;     362         PORTB=x;
;	x -> Y+2
;	y -> Y+1
;	blanking -> Y+0
	LDD  R30,Y+2
	OUT  0x5,R30
;     363         PORTC=4|(x>>6);
	RCALL SUBOPT_0x1E
;     364         PORTC.2=0;
	CBI  0x8,2
;     365         PORTC.2=1;
	SBI  0x8,2
;     366         PORTB=y;
	LDD  R30,Y+1
	OUT  0x5,R30
;     367         PORTC=4|(y>>6);
	RCALL SUBOPT_0x1E
;     368         PORTD.7=0;
	CBI  0xB,7
;     369         PORTD.7=1;
	SBI  0xB,7
;     370         PORTD.6=blanking;
	LD   R30,Y
	CPI  R30,0
	BRNE _0x9C
	CBI  0xB,6
	RJMP _0x9D
_0x9C:
	SBI  0xB,6
_0x9D:
;     371         return;
	ADIW R28,3
	RET
;     372 
;     373 }
;     374 
;     375 void test(void)//Laser test patterns
;     376 {
_test:
;     377         unsigned char i=0;
;     378         unsigned char counter=0;
;     379         #asm("sei");
	RCALL __SAVELOCR2
;	i -> R17
;	counter -> R16
	LDI  R16,0
	LDI  R17,0
	sei
;     380         while(1)
_0x9E:
;     381         {
;     382                 #asm("wdr");
	wdr
;     383                 if(next==1)
	LDI  R30,LOW(1)
	CP   R30,R4
	BRNE _0xA1
;     384                 {
;     385                         ++counter;
	SUBI R16,-LOW(1)
;     386                         if(counter>3) counter=0;
	CPI  R16,4
	BRLO _0xA2
	LDI  R16,LOW(0)
;     387                         next=0;
_0xA2:
	CLR  R4
;     388                 };
_0xA1:
;     389                 if(counter==0)
	CPI  R16,0
	BRNE _0xA3
;     390                 {
;     391                         for(i=0;i<=254;i++)
	LDI  R17,LOW(0)
_0xA5:
	CPI  R17,255
	BRSH _0xA6
;     392                         {
;     393                                 if((i<85)||(i>170))
	CPI  R17,85
	BRLO _0xA8
	CPI  R17,171
	BRLO _0xA7
_0xA8:
;     394                                 {
;     395                                         out(i,0,1);
	ST   -Y,R17
	LDI  R30,LOW(0)
	RJMP _0xE9
;     396                                 }
;     397                                 else
_0xA7:
;     398                                 {
;     399                                         out(i,255,1);
	ST   -Y,R17
	LDI  R30,LOW(255)
_0xE9:
	ST   -Y,R30
	RCALL SUBOPT_0xA
	RCALL _out
;     400                                 };
;     401                                 delay_us(100);
	RCALL SUBOPT_0xB
;     402                         };
	SUBI R17,-1
	RJMP _0xA5
_0xA6:
;     403                 }
;     404                 else if(counter==1)
	RJMP _0xAB
_0xA3:
	CPI  R16,1
	BRNE _0xAC
;     405                 {
;     406                         for(i=0;i<=254;i++)
	LDI  R17,LOW(0)
_0xAE:
	CPI  R17,255
	BRSH _0xAF
;     407                         {
;     408                                 if((i<85)||(i>170)) out(0,i,1);
	CPI  R17,85
	BRLO _0xB1
	CPI  R17,171
	BRLO _0xB0
_0xB1:
	LDI  R30,LOW(0)
	RJMP _0xEA
;     409                                 else out(255,i,1);
_0xB0:
	LDI  R30,LOW(255)
_0xEA:
	ST   -Y,R30
	ST   -Y,R17
	RCALL SUBOPT_0xA
	RCALL _out
;     410                                 delay_us(100);
	RCALL SUBOPT_0xB
;     411                         };
	SUBI R17,-1
	RJMP _0xAE
_0xAF:
;     412 
;     413                 }
;     414                 else if(counter==2)
	RJMP _0xB4
_0xAC:
	CPI  R16,2
	BRNE _0xB5
;     415                 {
;     416                         for(i=0;i<=254;i++)
	LDI  R17,LOW(0)
_0xB7:
	CPI  R17,255
	BRSH _0xB8
;     417                         {
;     418                                 out(0,i,1);
	RCALL SUBOPT_0x4
	ST   -Y,R17
	RCALL SUBOPT_0xA
	RCALL SUBOPT_0x1F
;     419                                 delay_us(10);
;     420                         };
	SUBI R17,-1
	RJMP _0xB7
_0xB8:
;     421                         for(i=0;i<=254;i++)
	LDI  R17,LOW(0)
_0xBA:
	CPI  R17,255
	BRSH _0xBB
;     422                         {
;     423                                 out(i,255,1);
	ST   -Y,R17
	LDI  R30,LOW(255)
	ST   -Y,R30
	RCALL SUBOPT_0xA
	RCALL SUBOPT_0x1F
;     424                                 delay_us(10);
;     425                         };
	SUBI R17,-1
	RJMP _0xBA
_0xBB:
;     426                         for(i=254;i>=1;i--)
	LDI  R17,LOW(254)
_0xBD:
	CPI  R17,1
	BRLO _0xBE
;     427                         {
;     428                                 out(255,i,1);
	LDI  R30,LOW(255)
	RCALL SUBOPT_0x18
	RCALL SUBOPT_0xA
	RCALL SUBOPT_0x1F
;     429                                 delay_us(10);
;     430                         };
	SUBI R17,1
	RJMP _0xBD
_0xBE:
;     431                         for(i=254;i>=1;i--)
	LDI  R17,LOW(254)
_0xC0:
	CPI  R17,1
	BRLO _0xC1
;     432                         {
;     433                                 out(i,0,1);
	RCALL SUBOPT_0x1A
	RCALL SUBOPT_0xA
	RCALL SUBOPT_0x1F
;     434                                 delay_us(10);
;     435                         };
	SUBI R17,1
	RJMP _0xC0
_0xC1:
;     436                 }
;     437                 else
	RJMP _0xC2
_0xB5:
;     438                 { ///>>>circle here
;     439                         circle(0.5,0);
	RCALL SUBOPT_0x20
	RCALL __PUTPARD1
	RCALL SUBOPT_0x4
	RCALL _circle
;     440                 };
_0xC2:
_0xB4:
_0xAB:
;     441 
;     442         };
	RJMP _0x9E
;     443 }
;     444 
;     445 // External Interrupt 0 service routine
;     446 interrupt [EXT_INT0] void ext_int0_isr(void)
;     447 {
_ext_int0_isr:
	ST   -Y,R30
;     448 // Place your code here
;     449                 next=1;
	LDI  R30,LOW(1)
	MOV  R4,R30
;     450                 repeat=200;
	LDI  R30,LOW(200)
	MOV  R5,R30
;     451 
;     452 }
	LD   R30,Y+
	RETI
;     453 
;     454 // External Interrupt 1 service routine
;     455 interrupt [EXT_INT1] void ext_int1_isr(void)
;     456 {
_ext_int1_isr:
	ST   -Y,R30
	IN   R30,SREG
	ST   -Y,R30
;     457 // Place your code here
;     458         if(loop)
	TST  R3
	BREQ _0xC3
;     459         {
;     460                 loop=0;
	CLR  R3
;     461                 increment=1;
	LDI  R30,LOW(1)
	MOV  R6,R30
;     462                 PORTD.5=0;
	CBI  0xB,5
;     463         }
;     464         else
	RJMP _0xC6
_0xC3:
;     465         {
;     466                 loop=1;
	LDI  R30,LOW(1)
	MOV  R3,R30
;     467                 increment=0;
	CLR  R6
;     468                 PORTD.5=1;
	SBI  0xB,5
;     469         };
_0xC6:
;     470 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R30,Y+
	RETI
;     471 
;     472 // Declare your global variables here
;     473 
;     474 void main(void)
;     475 {
_main:
;     476 // Declare your local variables here
;     477 char i;
;     478 // Crystal Oscillator division factor: 1
;     479 #pragma optsize-
;     480 CLKPR=0x80;
;	i -> R17
	LDI  R30,LOW(128)
	STS  97,R30
;     481 CLKPR=0x00;
	LDI  R30,LOW(0)
	STS  97,R30
;     482 #ifdef _OPTIMIZE_SIZE_
;     483 #pragma optsize+
;     484 #endif
;     485 
;     486 // Input/Output Ports initialization
;     487 // Port B initialization
;     488 // Func7=In Func6=In Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
;     489 // State7=T State6=T State5=0 State4=0 State3=0 State2=0 State1=0 State0=0
;     490 PORTB=0x00;
	OUT  0x5,R30
;     491 DDRB=0x3F;
	LDI  R30,LOW(63)
	OUT  0x4,R30
;     492 
;     493 // Port C initialization
;     494 // Func6=In Func5=In Func4=In Func3=In Func2=Out Func1=Out Func0=Out
;     495 // State6=T State5=T State4=T State3=T State2=0 State1=0 State0=0
;     496 PORTC=56;//PC3,4,5 pullup
	LDI  R30,LOW(56)
	OUT  0x8,R30
;     497 DDRC=0x07;
	LDI  R30,LOW(7)
	OUT  0x7,R30
;     498 
;     499 // Port D initialization
;     500 // Func7=Out Func6=Out Func5=Out Func4=In Func3=In Func2=In Func1=In Func0=In
;     501 // State7=0 State6=0 State5=0 State4=T State3=T State2=T State1=T State0=T
;     502 PORTD=0x00;
	LDI  R30,LOW(0)
	OUT  0xB,R30
;     503 DDRD=0xE0;
	LDI  R30,LOW(224)
	OUT  0xA,R30
;     504 
;     505 // Timer/Counter 0 initialization
;     506 // Clock source: System Clock
;     507 // Clock value: Timer 0 Stopped
;     508 // Mode: Normal top=FFh
;     509 // OC0A output: Disconnected
;     510 // OC0B output: Disconnected
;     511 TCCR0A=0x00;
	LDI  R30,LOW(0)
	OUT  0x24,R30
;     512 TCCR0B=0x00;
	OUT  0x25,R30
;     513 TCNT0=0x00;
	OUT  0x26,R30
;     514 OCR0A=0x00;
	OUT  0x27,R30
;     515 OCR0B=0x00;
	OUT  0x28,R30
;     516 
;     517 // Timer/Counter 1 initialization
;     518 // Clock source: System Clock
;     519 // Clock value: Timer 1 Stopped
;     520 // Mode: Normal top=FFFFh
;     521 // OC1A output: Discon.
;     522 // OC1B output: Discon.
;     523 // Noise Canceler: Off
;     524 // Input Capture on Falling Edge
;     525 // Timer 1 Overflow Interrupt: Off
;     526 // Input Capture Interrupt: Off
;     527 // Compare A Match Interrupt: Off
;     528 // Compare B Match Interrupt: Off
;     529 TCCR1A=0x00;
	STS  128,R30
;     530 TCCR1B=0x00;
	STS  129,R30
;     531 TCNT1H=0x00;
	STS  133,R30
;     532 TCNT1L=0x00;
	STS  132,R30
;     533 ICR1H=0x00;
	STS  135,R30
;     534 ICR1L=0x00;
	STS  134,R30
;     535 OCR1AH=0x00;
	STS  137,R30
;     536 OCR1AL=0x00;
	STS  136,R30
;     537 OCR1BH=0x00;
	STS  139,R30
;     538 OCR1BL=0x00;
	STS  138,R30
;     539 
;     540 // Timer/Counter 2 initialization
;     541 // Clock source: System Clock
;     542 // Clock value: Timer 2 Stopped
;     543 // Mode: Normal top=FFh
;     544 // OC2A output: Disconnected
;     545 // OC2B output: Disconnected
;     546 ASSR=0x00;
	STS  182,R30
;     547 TCCR2A=0x00;
	STS  176,R30
;     548 TCCR2B=0x00;
	STS  177,R30
;     549 TCNT2=0x00;
	STS  178,R30
;     550 OCR2A=0x00;
	STS  179,R30
;     551 OCR2B=0x00;
	STS  180,R30
;     552 
;     553 // External Interrupt(s) initialization
;     554 // INT0: On
;     555 // INT0 Mode: Falling Edge
;     556 // INT1: On
;     557 // INT1 Mode: Falling Edge
;     558 // Interrupt on any change on pins PCINT0-7: Off
;     559 // Interrupt on any change on pins PCINT8-14: Off
;     560 // Interrupt on any change on pins PCINT16-23: Off
;     561 EICRA=0x0A;
	LDI  R30,LOW(10)
	STS  105,R30
;     562 EIMSK=0x03;
	LDI  R30,LOW(3)
	OUT  0x1D,R30
;     563 EIFR=0x03;
	OUT  0x1C,R30
;     564 PCICR=0x00;
	LDI  R30,LOW(0)
	STS  104,R30
;     565 
;     566 // Timer/Counter 0 Interrupt(s) initialization
;     567 TIMSK0=0x00;
	STS  110,R30
;     568 // Timer/Counter 1 Interrupt(s) initialization
;     569 TIMSK1=0x00;
	STS  111,R30
;     570 // Timer/Counter 2 Interrupt(s) initialization
;     571 TIMSK2=0x00;
	STS  112,R30
;     572 
;     573 // Analog Comparator initialization
;     574 // Analog Comparator: Off
;     575 // Analog Comparator Input Capture by Timer/Counter 1: Off
;     576 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x30,R30
;     577 ADCSRB=0x00;
	LDI  R30,LOW(0)
	STS  123,R30
;     578 
;     579 // 2 Wire Bus initialization
;     580 // Generate Acknowledge Pulse: On
;     581 // 2 Wire Bus Slave Address: 0h
;     582 // General Call Recognition: Off
;     583 // Bit Rate: 400,000 kHz
;     584 TWSR=0x00;
	STS  185,R30
;     585 TWBR=0x0C;
	LDI  R30,LOW(12)
	STS  184,R30
;     586 TWAR=0x00;
	LDI  R30,LOW(0)
	STS  186,R30
;     587 TWCR=0x44;
	LDI  R30,LOW(68)
	RCALL SUBOPT_0x1
;     588 
;     589 // Watchdog Timer initialization
;     590 // Watchdog Timer Prescaler: OSC/1024k
;     591 // Watchdog Timer interrupt: Off
;     592 #pragma optsize-
;     593 //#asm("wdr")
;     594 WDTCSR=0x39;
	LDI  R30,LOW(57)
	STS  96,R30
;     595 WDTCSR=0x29;
	LDI  R30,LOW(41)
	STS  96,R30
;     596 #ifdef _OPTIMIZE_SIZE_
;     597 #pragma optsize+
;     598 #endif
;     599 
;     600 //delay_ms(1000);//vremya ustanovki vhodov
;     601 for(i=0;i<=20;i++)
	LDI  R17,LOW(0)
_0xCA:
	CPI  R17,21
	BRSH _0xCB
;     602 {
;     603         if((~PIND.2)&(~PIND.3)) test();//vhod v testoviy rejim
	LDI  R30,0
	SBIS 0x9,2
	LDI  R30,1
	MOV  R26,R30
	LDI  R30,0
	SBIS 0x9,3
	LDI  R30,1
	AND  R30,R26
	BREQ _0xCC
	RCALL _test
;     604         delay_ms(100);
_0xCC:
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
;     605         #asm("wdr");
	wdr
;     606 };
	SUBI R17,-1
	RJMP _0xCA
_0xCB:
;     607 while(PIND.2&PIND.3) #asm("wdr");//jdat' poka ne najata kakaya-nibud' knopka
_0xCD:
	LDI  R30,0
	SBIC 0x9,2
	LDI  R30,1
	MOV  R26,R30
	LDI  R30,0
	SBIC 0x9,3
	LDI  R30,1
	AND  R30,R26
	BREQ _0xCF
	wdr
	RJMP _0xCD
_0xCF:
;     608 
;     609 // Global enable interrupts
;     610 #asm("sei")
	sei
;     611 //test();
;     612 while (1)
_0xD0:
;     613       {
;     614       // Place your code here
;     615       if(PINC.3==1)
	SBIS 0x6,3
	RJMP _0xD3
;     616         select_effect();
	RCALL _select_effect
;     617       else
	RJMP _0xD4
_0xD3:
;     618         read_picture();
	RCALL _read_picture
;     619       };
_0xD4:
	RJMP _0xD0
;     620 }
_0xD5:
	RJMP _0xD5

_sin:
	SBIW R28,4
	ST   -Y,R17
	LDI  R17,0
	RCALL SUBOPT_0x21
	__GETD1N 0x3E22F983
	RCALL __MULF12
	RCALL SUBOPT_0x22
	RCALL SUBOPT_0x23
	RCALL __PUTPARD1
	RCALL _floor
	RCALL SUBOPT_0x21
	RCALL __SWAPD12
	RCALL __SUBF12
	RCALL SUBOPT_0x22
	RCALL SUBOPT_0x21
	RCALL SUBOPT_0x20
	RCALL __CMPF12
	BREQ PC+2
	BRCC PC+2
	RJMP _0xD6
	RCALL SUBOPT_0x21
	RCALL SUBOPT_0x20
	RCALL __SWAPD12
	RCALL __SUBF12
	RCALL SUBOPT_0x22
	LDI  R17,LOW(1)
_0xD6:
	RCALL SUBOPT_0x21
	__GETD1N 0x3E800000
	RCALL __CMPF12
	BREQ PC+2
	BRCC PC+2
	RJMP _0xD7
	RCALL SUBOPT_0x21
	RCALL SUBOPT_0x20
	RCALL __SUBF12
	RCALL SUBOPT_0x22
_0xD7:
	CPI  R17,0
	BREQ _0xD8
	RCALL SUBOPT_0x23
	RCALL __ANEGF1
	RCALL SUBOPT_0x22
_0xD8:
	RCALL SUBOPT_0x23
	RCALL SUBOPT_0x21
	RCALL __MULF12
	__PUTD1S 1
	RCALL SUBOPT_0x24
	__GETD2N 0x4226C4B1
	RCALL __MULF12
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x422DE51D
	RCALL __SWAPD12
	RCALL __SUBF12
	RCALL SUBOPT_0x25
	__GETD2N 0x4104534C
	RCALL __ADDF12
	RCALL SUBOPT_0x21
	RCALL __MULF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x24
	__GETD2N 0x3FDEED11
	RCALL __ADDF12
	RCALL SUBOPT_0x25
	__GETD2N 0x3FA87B5E
	RCALL __ADDF12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	RCALL __DIVF21
	LDD  R17,Y+0
	ADIW R28,9
	RET
_cos:
	__GETD2S 0
	__GETD1N 0x3FC90FDB
	RCALL __SUBF12
	RCALL __PUTPARD1
	RCALL _sin
	ADIW R28,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x0:
	LDS  R30,188
	ANDI R30,LOW(0x80)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1:
	STS  188,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2:
	RCALL _twi_start
	LDI  R30,LOW(160)
	ST   -Y,R30
	RJMP _twi_write

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x3:
	ST   -Y,R30
	RJMP _twi_write

;OPTIMIZER ADDED SUBROUTINE, CALLED 16 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x4:
	LDI  R30,LOW(0)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x5:
	ST   -Y,R31
	ST   -Y,R30
	RJMP _ee_read

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x6:
	STD  Y+12,R30
	STD  Y+12+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x7:
	LDD  R30,Y+12
	LDD  R31,Y+12+1
	ADIW R30,1
	RCALL SUBOPT_0x6
	RJMP SUBOPT_0x5

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x8:
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x9:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	CP   R30,R20
	CPC  R31,R21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 13 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0xA:
	LDI  R30,LOW(1)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0xB:
	__DELAY_USW 400
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xC:
	RCALL _effect1
	MOV  R30,R4
	RCALL __LNEGB1
	AND  R30,R3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xD:
	RCALL _effect2
	MOV  R30,R4
	RCALL __LNEGB1
	AND  R30,R3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xE:
	MOV  R30,R4
	RCALL __LNEGB1
	AND  R30,R3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xF:
	__GETD2S 2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x10:
	__GETD1S 2
	RCALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x11:
	__GETD2N 0x42FE0000
	RCALL __MULF12
	RCALL __CFD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x12:
	__DELAY_USW 2800
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:14 WORDS
SUBOPT_0x13:
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	ST   -Y,R31
	ST   -Y,R30
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x14:
	RCALL __ADDF12
	__PUTD1S 2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x15:
	LDI  R19,LOW(0)
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	ST   -Y,R31
	ST   -Y,R30
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x16:
	LDD  R30,Y+4
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:19 WORDS
SUBOPT_0x17:
	MOV  R26,R19
	LDI  R30,LOW(51)
	MUL  R30,R26
	MOVW R30,R0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x18:
	ST   -Y,R30
	ST   -Y,R17
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x19:
	ST   -Y,R30
	RJMP _out

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1A:
	ST   -Y,R17
	RJMP SUBOPT_0x4

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1B:
	LDI  R30,LOW(255)
	SUB  R30,R17
	MOV  R19,R30
	MOV  R16,R19
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x1C:
	CBI  0xB,6
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
	SBI  0xB,6
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1D:
	__DELAY_USW 320
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x1E:
	SWAP R30
	ANDI R30,0xF
	LSR  R30
	LSR  R30
	ORI  R30,4
	OUT  0x8,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x1F:
	RCALL _out
	__DELAY_USB 53
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x20:
	__GETD1N 0x3F000000
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:19 WORDS
SUBOPT_0x21:
	__GETD2S 5
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x22:
	__PUTD1S 5
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x23:
	__GETD1S 5
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x24:
	__GETD1S 1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x25:
	__GETD2S 1
	RCALL __MULF12
	RET

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0xFA0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ftrunc:
	ldd  r23,y+3
	ldd  r22,y+2
	ldd  r31,y+1
	ld   r30,y
	bst  r23,7
	lsl  r23
	sbrc r22,7
	sbr  r23,1
	mov  r25,r23
	subi r25,0x7e
	breq __ftrunc0
	brcs __ftrunc0
	cpi  r25,24
	brsh __ftrunc1
	clr  r26
	clr  r27
	clr  r24
__ftrunc2:
	sec
	ror  r24
	ror  r27
	ror  r26
	dec  r25
	brne __ftrunc2
	and  r30,r26
	and  r31,r27
	and  r22,r24
	rjmp __ftrunc1
__ftrunc0:
	clt
	clr  r23
	clr  r30
	clr  r31
	clr  r22
__ftrunc1:
	cbr  r22,0x80
	lsr  r23
	brcc __ftrunc3
	sbr  r22,0x80
__ftrunc3:
	bld  r23,7
	ld   r26,y+
	ld   r27,y+
	ld   r24,y+
	ld   r25,y+
	cp   r30,r26
	cpc  r31,r27
	cpc  r22,r24
	cpc  r23,r25
	bst  r25,7
	ret

_floor:
	rcall __ftrunc
	brne __floor1
__floor0:
	ret
__floor1:
	brtc __floor0
	ldi  r25,0xbf

__addfc:
	clr  r26
	clr  r27
	ldi  r24,0x80
	rjmp __addf12

__ANEGD1:
	COM  R31
	COM  R22
	COM  R23
	NEG  R30
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__LNEGB1:
	TST  R30
	LDI  R30,1
	BREQ __LNEGB1F
	CLR  R30
__LNEGB1F:
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SWAPD12:
	MOV  R1,R24
	MOV  R24,R22
	MOV  R22,R1
	MOV  R1,R25
	MOV  R25,R23
	MOV  R23,R1

__SWAPW12:
	MOV  R1,R27
	MOV  R27,R31
	MOV  R31,R1

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__ANEGF1:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __ANEGF10
	SUBI R23,0x80
__ANEGF10:
	RET

__ROUND_REPACK:
	TST  R21
	BRPL __REPACK
	CPI  R21,0x80
	BRNE __ROUND_REPACK0
	SBRS R30,0
	RJMP __REPACK
__ROUND_REPACK0:
	ADIW R30,1
	ADC  R22,R25
	ADC  R23,R25
	BRVS __REPACK1

__REPACK:
	LDI  R21,0x80
	EOR  R21,R23
	BRNE __REPACK0
	PUSH R21
	RJMP __ZERORES
__REPACK0:
	CPI  R21,0xFF
	BREQ __REPACK1
	LSL  R22
	LSL  R0
	ROR  R21
	ROR  R22
	MOV  R23,R21
	RET
__REPACK1:
	PUSH R21
	TST  R0
	BRMI __REPACK2
	RJMP __MAXRES
__REPACK2:
	RJMP __MINRES

__UNPACK:
	LDI  R21,0x80
	MOV  R1,R25
	AND  R1,R21
	LSL  R24
	ROL  R25
	EOR  R25,R21
	LSL  R21
	ROR  R24

__UNPACK1:
	LDI  R21,0x80
	MOV  R0,R23
	AND  R0,R21
	LSL  R22
	ROL  R23
	EOR  R23,R21
	LSL  R21
	ROR  R22
	RET

__CFD1U:
	SET
	RJMP __CFD1U0
__CFD1:
	CLT
__CFD1U0:
	PUSH R21
	RCALL __UNPACK1
	CPI  R23,0x80
	BRLO __CFD10
	CPI  R23,0xFF
	BRCC __CFD10
	RJMP __ZERORES
__CFD10:
	LDI  R21,22
	SUB  R21,R23
	BRPL __CFD11
	NEG  R21
	CPI  R21,8
	BRTC __CFD19
	CPI  R21,9
__CFD19:
	BRLO __CFD17
	SER  R30
	SER  R31
	SER  R22
	LDI  R23,0x7F
	BLD  R23,7
	RJMP __CFD15
__CFD17:
	CLR  R23
	TST  R21
	BREQ __CFD15
__CFD18:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	DEC  R21
	BRNE __CFD18
	RJMP __CFD15
__CFD11:
	CLR  R23
__CFD12:
	CPI  R21,8
	BRLO __CFD13
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R23
	SUBI R21,8
	RJMP __CFD12
__CFD13:
	TST  R21
	BREQ __CFD15
__CFD14:
	LSR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	DEC  R21
	BRNE __CFD14
__CFD15:
	TST  R0
	BRPL __CFD16
	RCALL __ANEGD1
__CFD16:
	POP  R21
	RET

__SWAPACC:
	PUSH R20
	MOVW R20,R30
	MOVW R30,R26
	MOVW R26,R20
	MOVW R20,R22
	MOVW R22,R24
	MOVW R24,R20
	MOV  R20,R0
	MOV  R0,R1
	MOV  R1,R20
	POP  R20
	RET

__UADD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	RET

__NEGMAN1:
	COM  R30
	COM  R31
	COM  R22
	SUBI R30,-1
	SBCI R31,-1
	SBCI R22,-1
	RET

__SUBF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129
	LDI  R21,0x80
	EOR  R1,R21

	RJMP __ADDF120

__ADDF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129

__ADDF120:
	CPI  R23,0x80
	BREQ __ADDF128
__ADDF121:
	MOV  R21,R23
	SUB  R21,R25
	BRVS __ADDF129
	BRPL __ADDF122
	RCALL __SWAPACC
	RJMP __ADDF121
__ADDF122:
	CPI  R21,24
	BRLO __ADDF123
	CLR  R26
	CLR  R27
	CLR  R24
__ADDF123:
	CPI  R21,8
	BRLO __ADDF124
	MOV  R26,R27
	MOV  R27,R24
	CLR  R24
	SUBI R21,8
	RJMP __ADDF123
__ADDF124:
	TST  R21
	BREQ __ADDF126
__ADDF125:
	LSR  R24
	ROR  R27
	ROR  R26
	DEC  R21
	BRNE __ADDF125
__ADDF126:
	MOV  R21,R0
	EOR  R21,R1
	BRMI __ADDF127
	RCALL __UADD12
	BRCC __ADDF129
	ROR  R22
	ROR  R31
	ROR  R30
	INC  R23
	BRVC __ADDF129
	RJMP __MAXRES
__ADDF128:
	RCALL __SWAPACC
__ADDF129:
	RCALL __REPACK
	POP  R21
	RET
__ADDF127:
	SUB  R30,R26
	SBC  R31,R27
	SBC  R22,R24
	BREQ __ZERORES
	BRCC __ADDF1210
	COM  R0
	RCALL __NEGMAN1
__ADDF1210:
	TST  R22
	BRMI __ADDF129
	LSL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVC __ADDF1210

__ZERORES:
	CLR  R30
	CLR  R31
	CLR  R22
	CLR  R23
	POP  R21
	RET

__MINRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	SER  R23
	POP  R21
	RET

__MAXRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	LDI  R23,0x7F
	POP  R21
	RET

__MULF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BREQ __ZERORES
	CPI  R25,0x80
	BREQ __ZERORES
	EOR  R0,R1
	SEC
	ADC  R23,R25
	BRVC __MULF124
	BRLT __ZERORES
__MULF125:
	TST  R0
	BRMI __MINRES
	RJMP __MAXRES
__MULF124:
	PUSH R0
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R17
	CLR  R18
	CLR  R25
	MUL  R22,R24
	MOVW R20,R0
	MUL  R24,R31
	MOV  R19,R0
	ADD  R20,R1
	ADC  R21,R25
	MUL  R22,R27
	ADD  R19,R0
	ADC  R20,R1
	ADC  R21,R25
	MUL  R24,R30
	RCALL __MULF126
	MUL  R27,R31
	RCALL __MULF126
	MUL  R22,R26
	RCALL __MULF126
	MUL  R27,R30
	RCALL __MULF127
	MUL  R26,R31
	RCALL __MULF127
	MUL  R26,R30
	ADD  R17,R1
	ADC  R18,R25
	ADC  R19,R25
	ADC  R20,R25
	ADC  R21,R25
	MOV  R30,R19
	MOV  R31,R20
	MOV  R22,R21
	MOV  R21,R18
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	POP  R0
	TST  R22
	BRMI __MULF122
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	RJMP __MULF123
__MULF122:
	INC  R23
	BRVS __MULF125
__MULF123:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__MULF127:
	ADD  R17,R0
	ADC  R18,R1
	ADC  R19,R25
	RJMP __MULF128
__MULF126:
	ADD  R18,R0
	ADC  R19,R1
__MULF128:
	ADC  R20,R25
	ADC  R21,R25
	RET

__DIVF21:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BRNE __DIVF210
	TST  R1
__DIVF211:
	BRPL __DIVF219
	RJMP __MINRES
__DIVF219:
	RJMP __MAXRES
__DIVF210:
	CPI  R25,0x80
	BRNE __DIVF218
__DIVF217:
	RJMP __ZERORES
__DIVF218:
	EOR  R0,R1
	SEC
	SBC  R25,R23
	BRVC __DIVF216
	BRLT __DIVF217
	TST  R0
	RJMP __DIVF211
__DIVF216:
	MOV  R23,R25
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R1
	CLR  R17
	CLR  R18
	CLR  R19
	CLR  R20
	CLR  R21
	LDI  R25,32
__DIVF212:
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	CPC  R20,R17
	BRLO __DIVF213
	SUB  R26,R30
	SBC  R27,R31
	SBC  R24,R22
	SBC  R20,R17
	SEC
	RJMP __DIVF214
__DIVF213:
	CLC
__DIVF214:
	ROL  R21
	ROL  R18
	ROL  R19
	ROL  R1
	ROL  R26
	ROL  R27
	ROL  R24
	ROL  R20
	DEC  R25
	BRNE __DIVF212
	MOVW R30,R18
	MOV  R22,R1
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	TST  R22
	BRMI __DIVF215
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVS __DIVF217
__DIVF215:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__CMPF12:
	TST  R25
	BRMI __CMPF120
	TST  R23
	BRMI __CMPF121
	CP   R25,R23
	BRLO __CMPF122
	BRNE __CMPF121
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	BRLO __CMPF122
	BREQ __CMPF123
__CMPF121:
	CLZ
	CLC
	RET
__CMPF122:
	CLZ
	SEC
	RET
__CMPF123:
	SEZ
	CLC
	RET
__CMPF120:
	TST  R23
	BRPL __CMPF122
	CP   R25,R23
	BRLO __CMPF121
	BRNE __CMPF122
	CP   R30,R26
	CPC  R31,R27
	CPC  R22,R24
	BRLO __CMPF122
	BREQ __CMPF123
	RJMP __CMPF121

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__LOADLOCR2P:
	LD   R16,Y+
	LD   R17,Y+
	RET

;END OF CODE MARKER
__END_OF_CODE:
